/* pin_request_dialog.vala
 *
 * Copyright (C) 2010  Anatoly Kudinov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Anatoly Kudinov <zz@rialabs.org>
 */


using Gtk;
using WebKit;
using Xml;

public class PinRequestDialog : Dialog {
        private MainWindow _parent;
        private WebView hosted_webview;
        
        public PinRequestDialog(MainWindow parent, string pin_url) {
                _parent = parent;
                this.modal = true;
                set_title(_("Pin request"));
                this.has_separator = false;
                hosted_webview = new WebView();
                this.vbox.pack_start (hosted_webview, false, true, 0);
                show_all();
                hosted_webview.load_committed.connect(on_load_finished);
                hosted_webview.document_load_finished.connect(on_load_finished);

				hosted_webview.open(pin_url);
        }
        
        private void on_load_finished(WebFrame frame) {
	        //&& (frame.load_status == LoadStatus.FINISHED)
	        if ((frame.uri == "http://api.twitter.com/oauth/authorize") ) {
		        string s = frame.get_data_source().get_data().str;
		        //oauth_pin
            	Regex re = new Regex("<div\\s+id=\"oauth_pin\">[^\\d]+(\\d+)");
            	MatchInfo* mi;
            	if(re.match(s, 0, out mi)) {
	            	_parent.pin = mi->fetch(1);
	            	response(ResponseType.ACCEPT);
            	}else {
	            	debug("NOPIN");
            	}
	        }
        }
}
